CMSIS-DSP: Vector Park Transform

| CMSIS-DSP Version 1.5.2 CMSIS DSP Software Library

- Main Page
- Usage and Description
- Reference

All Data Structures Files Functions Variables Typedefs Enumerations Enumerator Macros Groups Pages
Functions
Vector Park Transform
Controller Functions

## Functions
CMSIS_INLINE __STATIC_INLINE void | arm_park_f32 (float32_t Ialpha, float32_t Ibeta, float32_t *pId, float32_t *pIq, float32_t sinVal, float32_t cosVal)
| Floating-point Park transform. More...
CMSIS_INLINE __STATIC_INLINE void | arm_park_q31 (q31_t Ialpha, q31_t Ibeta, q31_t *pId, q31_t *pIq, q31_t sinVal, q31_t cosVal)
| Park transform for Q31 version. More...

## Description

Forward Park transform converts the input two-coordinate vector to flux and torque components. The Park transform can be used to realize the transformation of the `Ialpha` and the `Ibeta` currents from the stationary to the moving reference frame and control the spatial relationship between the stator vector current and rotor flux vector. If we consider the d axis aligned with the rotor flux, the diagram below shows the current vector and the relationship from the two reference frames:

Stator current space vector and its component in (a,b) and in the d,q rotating reference frame

The function operates on a single sample of data and each call to the function returns the processed output. The library provides separate functions for Q31 and floating-point data types.

Algorithm
  where `Ialpha` and `Ibeta` are the stator vector components, `pId` and `pIq` are rotor vector components and `cosVal` and `sinVal` are the cosine and sine values of theta (rotor flux position).

Fixed-Point Behavior
  Care must be taken when using the Q31 version of the Park transform. In particular, the overflow and saturation behavior of the accumulator used must be considered. Refer to the function specific documentation below for usage guidelines.

## Function Documentation

CMSIS_INLINE __STATIC_INLINE void arm_park_f32 | ( | float32_t | Ialpha,
|  | float32_t | Ibeta,
|  | float32_t * | pId,
|  | float32_t * | pIq,
|  | float32_t | sinVal,
|  | float32_t | cosVal
| ) |  |

Parameters

  [in] | Ialpha | input two-phase vector coordinate alpha
  [in] | Ibeta | input two-phase vector coordinate beta
  [out] | pId | points to output rotor reference frame d
  [out] | pIq | points to output rotor reference frame q
  [in] | sinVal | sine value of rotation angle theta
  [in] | cosVal | cosine value of rotation angle theta

The function implements the forward Park transform.

CMSIS_INLINE __STATIC_INLINE void arm_park_q31 | ( | q31_t | Ialpha,
|  | q31_t | Ibeta,
|  | q31_t * | pId,
|  | q31_t * | pIq,
|  | q31_t | sinVal,
|  | q31_t | cosVal
| ) |  |

Parameters

  [in] | Ialpha | input two-phase vector coordinate alpha
  [in] | Ibeta | input two-phase vector coordinate beta
  [out] | pId | points to output rotor reference frame d
  [out] | pIq | points to output rotor reference frame q
  [in] | sinVal | sine value of rotation angle theta
  [in] | cosVal | cosine value of rotation angle theta

Scaling and Overflow Behavior:

  The function is implemented using an internal 32-bit accumulator. The accumulator maintains 1.31 format by truncating lower 31 bits of the intermediate multiplication in 2.62 format. There is saturation on the addition and subtraction, hence there is no risk of overflow.

References __QADD(), and __QSUB().